#!/bin/sh

#####check, if second instance is running#####
if [ -f ./data/assoc.pid ]; then
  pid=$(cat ./data/assoc.pid)
  rm ./data/assoc.pid
fi
if [ "$pid" = "" ]; then
  pid="wrtbwlog_nopid"
fi
echo $$ > ./data/assoc.pid

if [ "$(ps|grep $pid|grep assoc.sh)" != "" ]; then
  kill $pid
fi

#####get config data#####
if [ -f "./data/config" ]; then
  wlnhst="$(cat "./data/config"|grep "wrt_wlnhst"|cut -d '=' -f2)"
  wlnmac="$(cat "./data/config"|grep "wrt_wlnmac"|cut -d '=' -f2)"
  wlncmd="$(cat "./data/config"|grep "wrt_wlncmd"|cut -d '=' -f2)"
fi

#####check for clients#####
if [ "1" = "1" ]; then
  curassoclist=$(/usr/sbin/wl assoclist)
  if [ -f ./data/preassoclist ]; then
    preassoclist=$(cat ./data/preassoclist)
    rm ./data/preassoclist
  else
    preassoclist=""
  fi
  echo "$curassoclist" > ./data/preassoclist
                      
  if [ "$curassoclist" != "$preassoclist" ]; then
    echo "------------------------------" >> ./data/assoclog
    date >> ./data/assoclog
    
    for macaddr in $curassoclist 
    do
      if [ "$macaddr" != "assoclist" ]; then
        #####print data to log#####
        rssi=$(/usr/sbin/wl rssi "$macaddr" | cut -d 's' -f4)
        chip=$(/usr/sbin/wl sta_info "$macaddr"|grep flags|cut -d 's' -f2)

        firmware=$(/usr/sbin/nvram get firmware_version)
        if [ "$(echo "$firmware"|grep "Talisman")" != "" ] || [ "$(echo "$firmware"|grep "Freeman")" != "" ]; then
          killall -ALRM dnsmasq
          dumpl=$(cat /tmp/udhcpd.leases|grep $(echo "$macaddr"|tr "[A-Z]" "[a-z]"))
          ipaddr=$(echo "$dumpl"|cut -d ' ' -f3)
          hostn=$(echo "$dumpl"|cut -d ' ' -f5)
        else
          dumpl=$(/usr/sbin/dumpleases|grep $(echo "$macaddr"|tr "[A-Z]" "[a-z]"))
          ipaddr=$(expr substr "$dumpl" 36 15)
          hostn=$(expr substr "$dumpl" 1 16)
        fi

        echo "MAC: $macaddr IP: $ipaddr HOSTNAME: $hostn RSSI:$rssi CHIP:$chip" >> ./data/assoclog

        #####run script when unauthorized hostname is being found#####
        if [ "$wlnhst" != "" ] && [ "$wlncmd" != "" ]; then
          wlnhst=",${wlnhst},"
          hostn=$(echo "$hostn"|sed 's/ *$//')
          if [ "$(echo "$wlnhst"|grep ",${hostn},")" = "" ]; then
            $wlncmd "hostname" "$hostn" 2> /dev/null
          fi
        fi

        #####run script when unauthorized MAC is being found#####
        if [ "$wlnmac" != "" ] && [ "$wlncmd" != "" ]; then
          if [ "$(echo "$wlnmac"|grep "$macaddr")" = "" ]; then
            $wlncmd "mac" "$macaddr" 2> /dev/null
          fi
        fi

      fi
    done
  fi
fi
