#!./haserl
Content-Type: text/html

<?
./header.sh

#####print current version#####
ver=$(cat ./ver) 2> /dev/null
echo "<h3>WRTbwlog v$ver</h3>"
	
#####read configuration file#####
if [ -f "./data/config" ]; then
  dwnloc=$(cat "./data/config"|grep "wrt_dwnloc"|cut -d '=' -f2)
fi

#####if no data in config file, use default values#####
if [ "$dwnloc" = "" ]; then
  dwnloc="http://wrt54g.hetos.de/"
fi

echo "Update server: $dwnloc"

#####Check, if new version is available#####
wget -q ${dwnloc}nver -P ./data 2> /dev/null

ver=$(cat ./ver) 2> /dev/null
nver=$(cat ./data/nver) 2> /dev/null

if [ "$ver" != "$nver" ] && [ "$nver" != "" ]; then
    echo "<h3 class=\"mark\">New version $nver available (<a href="http://www.hetos.de/bwlog_change.html">Changelog</a>).</h3>"
  else
    echo "<h3>No new version available.</h3>"
fi

#####Remove versioncheck file#####
if [ -f "./data/nver" ]; then
  rm ./data/nver
fi

#####If Update Button has been pressed#####
if [ "$FORM_update" != "" ]; then

  #####Delete old .tgz and Download new version#####
  if [ -f "/tmp/$FORM_update" ]; then
    rm /tmp/wrtbw*.tgz 2> /dev/null
  fi
  echo "<h5>Downloading new version...</h5>"
  wget ${dwnloc}${FORM_update} -P /tmp

  #####Check, if it's a valid tar file#####
  tartest=`tar -tzf /tmp/$FORM_update`
  
  #####Only continue updating, if download was successfull#####
  if [ -f "/tmp/$FORM_update" ] && [ "$tartest" != "" ]; then
    
    #####Version dependant#####
                                          
    #####Killing running scripts#####
    echo "<h5>Killing running instances of WRTbwlog...</h5>"
    ./stop.sh 1ls
                                                                                              
    #####Remove WRTbwlog (Except logfiles)#####
    echo "<h5>Removing WRTbwlog (except the logfiles)...</h5>"
    rm /tmp/bwlog/*
                                                                                                                
    #####Extract new version#####
    echo "<h5>Extracting new version...</h5>"
    tar -xzvf /tmp/$FORM_update -C /tmp
    
    #####Start new version#####                                                                                                                              
    ./start.sh hl 1> /dev/null 2> /dev/null &
    echo "<h3>Update finished!</h3>"
    echo "Please close and restart your webbrowser to use the new version."
  else
    echo "<h3>Update failed!</h3>"
  fi 
else
  #####Update button#####
  echo "<form action=\"http://$HTTP_HOST$SCRIPT_NAME\" method=\"POST\" >"
  echo "(DON'T change the value in this field!)"
  echo "<input type=\"text\" class=\"TextBox\" style=\"width: 10em;\" name=\"update\" value=\"wrtbwlog.tgz\" >"
  echo "<input type=\"submit\" class=\"Button\" value=\"Update WRTbwlog now\" >"
  echo "</form>"
fi

echo "<hr class=\"ruler\"/>"

echo "<h3>Download & install new themes</h3>"

#####If Theme Button has been pressed#####
if [ "$FORM_theme" != "" ]; then
  themename=$(basename "$FORM_theme")
  if [ -f ./$themename ]; then
    echo "<p>A theme with this name is already installed!</p>"
  else
    wget "$FORM_theme"
    if [ -f ./$themename ]; then
      echo "<p>Theme successfully installed!</p>"
      echo "<p>You can select the new theme now on the configutation page.</p>"
    else
       echo "<p>Failed to install new theme!</p>"
    fi
  fi
fi

#####Install theme button#####
echo "<form action=\"http://$HTTP_HOST$SCRIPT_NAME\" method=\"POST\" >"
echo "URL of a theme:"
echo "<input type=\"text\" class=\"TextBox\" style=\"width: 20em;\" name=\"theme\" value=\"\" >"
echo "<input type=\"submit\" class=\"Button\" value=\"Install Theme\" >"
echo "</form>"

./footer.sh
?>
